# ======================================================================================================================
#  fennec, a free and open source game engine
#  Copyright © 2025 - 2026  Medusa Slockbower
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# ======================================================================================================================

import gdb

# ALLOCATION ===========================================================================================================
class AllocationPrinter:
    def __init__(self, val):
        self.val = val

    def to_string(self):
        return "{ capacity = " + str(self.val['_capacity']) + " }"

    def children(self):
        size = int(self.val['_capacity'])
        start = self.val['_data']
        return (('[{}]'.format(i), start[i]) for i in range(size))


# GDB Code =============================================================================================================

def register_printers():
    print("registering memory")
    pp = gdb.printing.RegexpCollectionPrettyPrinter("fennec::memory")
    pp.add_printer('fennec::allocation', '^fennec::allocation<.*>$', AllocationPrinter)
    return pp

printer = register_printers()